package com.logicbig.example;

import javax.swing.*;
import javax.swing.event.TreeSelectionListener;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.TreePath;
import java.awt.*;
import java.util.Hashtable;

public class TreeExampleMain {
    public static void main(String[] args) {
        Hashtable<?, ?> projectHierarchy =
                TradingProjectDataService.instance.getProjectHierarchy();
        JTree tree = new JTree(projectHierarchy);
        tree.addTreeSelectionListener(createTreeSelectionListener());
        JFrame frame = createFrame();
        frame.add(new JScrollPane(tree));
        frame.setLocationRelativeTo(null);
        frame.setVisible(true);
    }

    private static TreeSelectionListener createTreeSelectionListener() {
        return treeSelectionEvent -> {
            TreePath path = treeSelectionEvent.getPath();
            System.out.println("Path: " + path);
            Object c = path.getLastPathComponent();
            DefaultMutableTreeNode node = (DefaultMutableTreeNode) c;
            System.out.println("User Object: " + node.getUserObject());
            System.out.println("---");
        };
    }

    private static JFrame createFrame() {
        JFrame frame = new JFrame("JTree basic example");
        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        frame.setSize(new Dimension(500, 400));
        return frame;
    }
}